Index: code/branches/ois_update/src/external/bullet/BulletCollision/NarrowPhaseCollision/btGjkPairDetector.cpp
===================================================================
--- code/branches/ois_update/src/external/bullet/BulletCollision/NarrowPhaseCollision/btGjkPairDetector.cpp	(revision 7563)
+++ code/branches/ois_update/src/external/bullet/BulletCollision/NarrowPhaseCollision/btGjkPairDetector.cpp	(revision 7564)
@@ -38,4 +38,10 @@
 int gNumGjkChecks = 0;
 
+#ifdef check
+struct CompilerError
+{
+    void CompilerError() {}
+};
+#endif
 
 
Index: code/branches/ois_update/src/libraries/core/Super.h
===================================================================
--- code/branches/ois_update/src/libraries/core/Super.h	(revision 7563)
+++ code/branches/ois_update/src/libraries/core/Super.h	(revision 7564)
@@ -94,8 +94,8 @@
         struct SuperFunctionCondition<functionnumber, T, 0, templatehack2> \
         { \
-            static void check() \
+            static void verify() \
             { \
                 SuperFunctionCondition<functionnumber, T, 0, templatehack2>::apply(static_cast<T*>(0)); \
-                SuperFunctionCondition<functionnumber + 1, T, 0, templatehack2>::check(); \
+                SuperFunctionCondition<functionnumber + 1, T, 0, templatehack2>::verify(); \
             } \
             \
@@ -132,7 +132,7 @@
         struct SuperFunctionCondition<functionnumber, baseclass, 0, templatehack2> \
         { \
-            static void check() \
-            { \
-                SuperFunctionCondition<functionnumber + 1, baseclass, 0, templatehack2>::check(); \
+            static void verify() \
+            { \
+                SuperFunctionCondition<functionnumber + 1, baseclass, 0, templatehack2>::verify(); \
             } \
         };
@@ -150,5 +150,5 @@
         struct SuperFunctionCondition<functionnumber, T, 0, templatehack2>
         {
-            static void check()
+            static void verify()
             {
                 // This call to the apply-function is the whole check. By calling the function with
@@ -156,6 +156,6 @@
                 SuperFunctionCondition<functionnumber, T, 0, templatehack2>::apply(static_cast<T*>(0));
 
-                // Go go the check for of next super-function (functionnumber + 1)
-                SuperFunctionCondition<functionnumber + 1, T, 0, templatehack2>::check();
+                // Go go the verify for of next super-function (functionnumber + 1)
+                SuperFunctionCondition<functionnumber + 1, T, 0, templatehack2>::verify();
             }
 
@@ -202,8 +202,8 @@
         struct SuperFunctionCondition<functionnumber, baseclass, 0, templatehack2> \
         { \
-            // The check function acts like the fallback - it advances to the check for the next super-function (functionnumber + 1)
-            static void check() \
-            { \
-                SuperFunctionCondition<functionnumber + 1, baseclass, 0, templatehack2>::check(); \
+            // The verify function acts like the fallback - it advances to the check for the next super-function (functionnumber + 1)
+            static void verify() \
+            { \
+                SuperFunctionCondition<functionnumber + 1, baseclass, 0, templatehack2>::verify(); \
             } \
         };
@@ -303,5 +303,5 @@
         struct SuperFunctionCondition
         {
-            static void check() {}
+            static void verify() {}
         };
 
@@ -338,7 +338,7 @@
             struct SuperFunctionCondition<functionnumber, T, templatehack1, templatehack2> \
             { \
-                static void check() \
+                static void verify() \
                 { \
-                    SuperFunctionCondition<functionnumber + 1, T, templatehack1, templatehack2>::check(); \
+                    SuperFunctionCondition<functionnumber + 1, T, templatehack1, templatehack2>::verify(); \
                 } \
             }; \
@@ -421,8 +421,8 @@
             // If this function gets called, the header-file of the super function is not
             // included, so this fallback template (templatehack not specialized) is used
-            static void check()
+            static void verify()
             {
                 // Calls the condition-check of the next super-function (functionnumber + 1)
-                SuperFunctionCondition<functionnumber + 1, T, templatehack1, templatehack2>::check();
+                SuperFunctionCondition<functionnumber + 1, T, templatehack1, templatehack2>::verify();
             }
         };
@@ -574,5 +574,5 @@
         virtual void createSuperFunctionCaller() const
         {
-            //SuperFunctionCondition<0, T, 0, 0>::check();
+            //SuperFunctionCondition<0, T, 0, 0>::verify();
         }
 
Index: code/branches/ois_update/src/modules/questsystem/QuestEffect.cc
===================================================================
--- code/branches/ois_update/src/modules/questsystem/QuestEffect.cc	(revision 7563)
+++ code/branches/ois_update/src/modules/questsystem/QuestEffect.cc	(revision 7564)
@@ -68,12 +68,12 @@
     /*static*/ bool QuestEffect::invokeEffects(PlayerInfo* player, std::list<QuestEffect*> & effects)
     {
-        bool check = true;
+        bool temp = true;
 
         COUT(4) << "Invoking QuestEffects on player: " << player << " ."  << std::endl;
 
         for (std::list<QuestEffect*>::iterator effect = effects.begin(); effect != effects.end(); effect++)
-            check = check && (*effect)->invoke(player);
+            temp = temp && (*effect)->invoke(player);
 
-        return check;
+        return temp;
     }
 
Index: code/branches/ois_update/src/modules/questsystem/QuestEffectBeacon.cc
===================================================================
--- code/branches/ois_update/src/modules/questsystem/QuestEffectBeacon.cc	(revision 7563)
+++ code/branches/ois_update/src/modules/questsystem/QuestEffectBeacon.cc	(revision 7564)
@@ -154,6 +154,6 @@
         COUT(4) << "QuestEffectBeacon executed on player: " << player << " ." << std::endl;
 
-        bool check = QuestEffect::invokeEffects(player, this->effects_); // Invoke the QuestEffects on the PlayerInfo.
-        if(check)
+        bool temp = QuestEffect::invokeEffects(player, this->effects_); // Invoke the QuestEffects on the PlayerInfo.
+        if(temp)
         {
             this->decrementTimes(); // Decrement the number of times the beacon can be used.
Index: code/branches/ois_update/src/modules/questsystem/effects/AddReward.cc
===================================================================
--- code/branches/ois_update/src/modules/questsystem/effects/AddReward.cc	(revision 7563)
+++ code/branches/ois_update/src/modules/questsystem/effects/AddReward.cc	(revision 7564)
@@ -105,11 +105,11 @@
         COUT(5) << "AddReward on player: " << player << " ." << std::endl;
 
-        bool check = true;
+        bool temp = true;
         for ( std::list<Rewardable*>::iterator reward = this->rewards_.begin(); reward != this->rewards_.end(); ++reward )
-            check = check && (*reward)->reward(player);
+            temp = temp && (*reward)->reward(player);
 
         COUT(4) << "Rewardable successfully added to player." << player << " ." << std::endl;
 
-        return check;
+        return temp;
     }
 