Index: /branches/network/src/lib/graphics/importer/height_map.cc
===================================================================
--- /branches/network/src/lib/graphics/importer/height_map.cc	(revision 7566)
+++ /branches/network/src/lib/graphics/importer/height_map.cc	(revision 7567)
@@ -595,11 +595,11 @@
  float c = normalVectorField [(xInt)][yInt].y;
 
- PRINTF(0)("a: %f \n" ,a);
-  PRINTF(0)("b: %f \n" ,b);
-   PRINTF(0)("c: %f \n" ,c);
+// PRINTF(0)("a: %f \n" ,a);
+//  PRINTF(0)("b: %f \n" ,b);
+//   PRINTF(0)("c: %f \n" ,c);
 
  height -= ( (a/c)*(x) + (b/c)*(y));
 
- PRINTF(0)("height: %f \n" ,height );
+// PRINTF(0)("height: %f \n" ,height );
  return (height + offsetZ);
 }
Index: /branches/network/src/lib/network/network_game_manager.cc
===================================================================
--- /branches/network/src/lib/network/network_game_manager.cc	(revision 7566)
+++ /branches/network/src/lib/network/network_game_manager.cc	(revision 7567)
@@ -61,4 +61,5 @@
 NetworkGameManager::~NetworkGameManager()
 {
+#if 0
   for ( int i = 0; i<outBuffer.size(); i++)
   {
@@ -66,8 +67,9 @@
       delete outBuffer[i].buffer;
   }
-
-}
-
-
+#endif
+
+}
+
+#if 0
 int NetworkGameManager::writeBytes(const byte* data, int length, int sender)
 {
@@ -154,5 +156,7 @@
   return i;
 }
-
+#endif
+
+#if 0
 int NetworkGameManager::readBytes(byte* data, int maxLength, int * reciever)
 {
@@ -186,5 +190,7 @@
   return 0;
 }
-
+#endif
+
+#if 0
 void NetworkGameManager::writeDebug() const
 {
@@ -194,4 +200,5 @@
 {
 }
+#endif
 
 
@@ -214,5 +221,7 @@
   else
   {
+#if 0
     this->requestCreateEntity( classID );
+#endif
     return -1;
   }
@@ -282,10 +291,12 @@
   else
   {
+#if 0
     this->requestRemoveEntity( uniqueID );
-  }
-}
-
-
-
+#endif
+  }
+}
+
+
+#if 0
 /*!
  * Creates the needed entity on the server if possible
@@ -305,5 +316,7 @@
   }
 }
-
+#endif
+
+#if 0
 /*!
  * Removes the specified entity on the server
@@ -323,4 +336,5 @@
   }
 }
+#endif
 
 /*!
@@ -331,4 +345,5 @@
 int NetworkGameManager::executeCreateEntity(ClassID classID, int uniqueID, int owner)
 {
+#if 0
   for ( int i = 0; i<outBuffer.size(); i++)
   {
@@ -345,5 +360,5 @@
       return -1;
   }
-
+#endif
   PRINTF(0)("ExecuteCreateEntity: server side: classID: %x, uniqueID: %i, owner: %i\n", classID, uniqueID, owner);
   doCreateEntity( classID, uniqueID, owner );
@@ -359,4 +374,5 @@
 void NetworkGameManager::executeRemoveEntity(int uniqueID)
 {
+#if 0
   for ( int i = 0; i<outBuffer.size(); i++)
   {
@@ -369,4 +385,5 @@
       return;
   }
+#endif
 
   doRemoveEntity(uniqueID);
@@ -382,4 +399,5 @@
 }
 
+#if 0
 /*!
  * Sends the Entities to the new connected client
@@ -437,4 +455,5 @@
   signalNewPlayer( userID );
 }
+#endif
 
 
@@ -442,4 +461,5 @@
 bool NetworkGameManager::signalNewPlayer(int userId)
 {
+#if 0
   if ( userId >= outBuffer.size() )
     resizeBufferVector( userId );
@@ -450,5 +470,5 @@
   PRINTF(0)("Request for creation: userid: %i, uniqueid: %i\n", userId, uniqueId);
   this->sendYouAre(uniqueId, userId);
-
+#endif
 }
 
@@ -472,5 +492,5 @@
 }
 
-
+#if 0
 /**
  * Creates a buffer for user n
@@ -492,4 +512,5 @@
   }
 }
+#endif
 
 /**
@@ -594,5 +615,5 @@
 }
 
-
+#if 0
 /**
  * Copies length bytes to the clientBuffer with error checking
@@ -613,5 +634,7 @@
   return true;
 }
-
+#endif
+
+#if 0
 /**
  * Reads data from clientBuffer with error checking
@@ -632,4 +655,5 @@
   return true;
 }
+#endif
 
 /**
@@ -685,5 +709,5 @@
   if ( !isServer() )
     return;
-
+#if 0
   if ( userID != 0 )
   {
@@ -696,6 +720,10 @@
   else
   {
+#endif
     doYouAre(uniqueID);
-  }
+#if 0
+  }
+#endif
+
 }
 
@@ -911,5 +939,5 @@
 }
 
-
+#if 0
 bool NetworkGameManager::writeToClientBuffer( clientBuffer & cb, byte b )
 {
@@ -924,4 +952,5 @@
   return true;
 }
+
 
 bool NetworkGameManager::writeToClientBuffer( clientBuffer & cb, int i )
@@ -938,4 +967,5 @@
   return true;
 }
-
-
+#endif
+
+
Index: /branches/network/src/lib/network/network_game_manager.h
===================================================================
--- /branches/network/src/lib/network/network_game_manager.h	(revision 7566)
+++ /branches/network/src/lib/network/network_game_manager.h	(revision 7567)
@@ -76,8 +76,10 @@
     { if (!NetworkGameManager::singletonRef) NetworkGameManager::singletonRef = new NetworkGameManager(); return NetworkGameManager::singletonRef; }
 
+#if 0
     virtual int writeBytes(const byte* data, int length, int sender);
     virtual int readBytes(byte* data, int maxLength, int * reciever);
     virtual void writeDebug() const;
     virtual void readDebug() const;
+#endif
 
     int createEntity( ClassID classID, int owner = 0 );
@@ -86,5 +88,7 @@
     void sendYouAre( int uniqueID, int userID );
 
+#if 0
     void sendEntityList(int userID);
+#endif
 
     bool signalNewPlayer(int userId);
@@ -109,9 +113,9 @@
 
     /* some network handlers helper functions */
-    void requestCreateEntity(ClassID classID);
+//    void requestCreateEntity(ClassID classID);
     int executeCreateEntity(ClassID classID, int uniqueID = 0, int owner = 0);
     BaseObject* doCreateEntity(ClassID classID, int uniqueID, int owner);
 
-    void requestRemoveEntity(int uniqueID);
+//    void requestRemoveEntity(int uniqueID);
     void executeRemoveEntity(int uniqueID);
     void doRemoveEntity(int uniqueID);
@@ -119,11 +123,12 @@
     void doYouAre( int uniqueID );
 
-    void requestPNodePath(const PNode* node1, const PNode* node2);
+//    void requestPNodePath(const PNode* node1, const PNode* node2);
     void executeRequestPNodePath(const PNode* node2, const PNode* node2);
     void doRequestPNodePath(const PNode* node1, const PNode* node2);
 
     bool canCreateEntity(ClassID classID);
+#if 0
+    void resizeBufferVector(int n);
 
-    void resizeBufferVector(int n);
 
     bool writeToClientBuffer( clientBuffer &cb, byte*data, int length );
@@ -131,9 +136,11 @@
     bool writeToClientBuffer( clientBuffer &cb, int i );
     bool readFromClientBuffer( clientBuffer &cb, byte*data, int length );
-
+#endif
 
   private:
+#if 0
     std::vector<clientBuffer>     outBuffer;
     //clientBuffer                  allOutBuffer;
+#endif
     static NetworkGameManager*    singletonRef;
     bool                          hasRequestedWorld;