Index: /code/branches/masterserver/src/modules/CMakeLists.txt
===================================================================
--- /code/branches/masterserver/src/modules/CMakeLists.txt	(revision 7567)
+++ /code/branches/masterserver/src/modules/CMakeLists.txt	(revision 7568)
@@ -34,2 +34,3 @@
 ADD_SUBDIRECTORY(questsystem)
 ADD_SUBDIRECTORY(weapons)
+ADD_SUBDIRECTORY(masterserver)
Index: /code/branches/masterserver/src/modules/masterserver/MasterServer.cpp
===================================================================
--- /code/branches/masterserver/src/modules/masterserver/MasterServer.cpp	(revision 7567)
+++ /code/branches/masterserver/src/modules/masterserver/MasterServer.cpp	(revision 7568)
@@ -6,6 +6,5 @@
 /* connect event */
 int eventConnect( ENetEvent *event )
-{ 
-  /* check for bad parameters */
+{ /* check for bad parameters */
   if( !event )
   { fprintf( stderr, "No event given.\n" );
@@ -35,6 +34,5 @@
 /* disconnect event */
 int eventDisconnect( ENetEvent *event )
-{ 
-  /* check for bad parameters */
+{ /* check for bad parameters */
   if( !event )
   { fprintf( stderr, "No event given.\n" );
@@ -54,6 +52,5 @@
 /* data event */
 int eventData( ENetEvent *event )
-{ 
-  /* output what's in the packet (to be removed later) */
+{ /* output what's in the packet (to be removed later) */
   if( !event || !(event->packet) || !(event->peer) || !(event->channelID) )
   { fprintf( stderr, "No complete event given.\n" );
@@ -61,5 +58,5 @@
   }
 
-
+  /* output debug info about the data that has come, to be removed */
   printf( "A packet of length %u containing %s was received from %s on channel %u.\n",
       event->packet->dataLength,
@@ -123,17 +120,21 @@
 
   /***** INITIALIZE GAME SERVER LIST *****/
-  ServerList mainlist = new ServerList();
-  if( !mainlist )
-  { fprintf( stderr, "Error creating server list.\n" );
-    exit( EXIT_FAILURE );
-  }
+  orxonox::ServerList *mainlist = new orxonox::ServerList();
+  //if( mainlist == NULL )
+  //{ fprintf( stderr, "Error creating server list.\n" );
+    //exit( EXIT_FAILURE );
+  //}
 
   /***** ENTER MAIN LOOP *****/
-  ENetEvent *event = calloc(sizeof(ENetEvent));
-  if( !event )
+  ENetEvent *event = calloc(sizeof(ENetEvent), sizeof(char));
+  if( event == NULL )
   { fprintf( stderr, "Could not create ENetEvent structure, exiting.\n" );
     exit( EXIT_FAILURE );
   }
 
+  /* NOTE this only waits on one client, we need to find some way to 
+   * actually listen on all active connections. This will be implemented 
+   * together with the list of active connections.
+   */
   /* Wait up to 1000 milliseconds for an event. */
   while (enet_host_service (client, event, 1000) > 0)
Index: /code/branches/masterserver/src/modules/masterserver/MasterServer.h
===================================================================
--- /code/branches/masterserver/src/modules/masterserver/MasterServer.h	(revision 7567)
+++ /code/branches/masterserver/src/modules/masterserver/MasterServer.h	(revision 7568)
@@ -4,13 +4,13 @@
 /* orxonox includes */
 #include <enet/enet.h>
-#include "packet/Chat.h"
-#include "packet/ClassID.h"
-#include "packet/DeleteObjects.h"
-#include "packet/FunctionIDs.h"
-#include "packet/Gamestate.h"
-#include "packet/Welcome.h"
+#include <network/packet/Chat.h>
+#include <network/packet/ClassID.h>
+#include <network/packet/DeleteObjects.h>
+#include <network/packet/FunctionIDs.h>
+#include <network/packet/Gamestate.h>
+#include <network/packet/Welcome.h>
 
 /* my includes */
-#include <ServerList.h>
+#include "ServerList.h"
 
 /* c compatibility */
Index: /code/branches/masterserver/src/modules/masterserver/ServerList.h
===================================================================
--- /code/branches/masterserver/src/modules/masterserver/ServerList.h	(revision 7567)
+++ /code/branches/masterserver/src/modules/masterserver/ServerList.h	(revision 7568)
@@ -32,5 +32,5 @@
 #include <list>
 #include <string>
-#include "ServerInformation.h"
+#include <network/packet/ServerInformation.h>
 
 /* methods necessary */
@@ -54,5 +54,5 @@
        * Add server to the game server list
        */
-      int addServer( ServerInformation *toadd );
+      int addServer( packet::ServerInformation *toadd );
 
       /** \param name Name of the server to remove
@@ -79,5 +79,5 @@
     private:
       /** the list of servers for internal storage */
-      std::list<ServerInformation *> serverlist;
+      std::list<packet::ServerInformation *> serverlist;
   };
 }