Index: code/branches/lastmanstanding/data/levels/gametype_lastmanstanding.oxw
===================================================================
--- code/branches/lastmanstanding/data/levels/gametype_lastmanstanding.oxw	(revision 7578)
+++ code/branches/lastmanstanding/data/levels/gametype_lastmanstanding.oxw	(revision 7579)
@@ -3,4 +3,5 @@
   include("hudtemplates3.oxo")
   include("templates/lodinformation.oxt")
+  include("lastmanstandinghud.oxo")
 ?>
 
@@ -103,4 +104,9 @@
            <!--ParticleEmitter position="0,0,0" source="Orxonox/Steam" /-->
        </attached>
+
+      <!--collisionShapes>
+        <BoxCollisionShape position="<?lua print(y) ?>,0,<?lua print(z) ?>"      halfExtents="50, 200, 50" />
+      </collisionShapes-->
+
   </MovableEntity>
 
Index: code/branches/lastmanstanding/data/overlays/dynamicmatchhud.oxo
===================================================================
--- code/branches/lastmanstanding/data/overlays/dynamicmatchhud.oxo	(revision 7578)
+++ code/branches/lastmanstanding/data/overlays/dynamicmatchhud.oxo	(revision 7579)
@@ -16,8 +16,9 @@
      position = "0.5, 0.05"
      font     = "VeraMono"
-     textsize = 0.04
+     textsize = 0.033
      colour   = "1.0, 1.0, 0.5, 1.0"
      align    = "center"
     />
+
   </OverlayGroup>
 </Template>
Index: code/branches/lastmanstanding/src/orxonox/gametypes/LastManStanding.cc
===================================================================
--- code/branches/lastmanstanding/src/orxonox/gametypes/LastManStanding.cc	(revision 7578)
+++ code/branches/lastmanstanding/src/orxonox/gametypes/LastManStanding.cc	(revision 7579)
@@ -34,4 +34,5 @@
 #include "worldentities/pawns/Pawn.h"
 #include "core/ConfigValueIncludes.h"
+#include "util/Convert.h"
 
 namespace orxonox
@@ -46,4 +47,5 @@
         this->playersAlive=0;
         this->timeRemaining=20.0f;
+        this->setHUDTemplate("LastmanstandingHUD");
     }
 
@@ -128,4 +130,13 @@
         COUT(0) << message << std::endl;
         Host::Broadcast(message);
+        //Update: EachPlayer's "Players in Game"-HUD
+        for (std::map<PlayerInfo*, Player>::iterator it = this->players_.begin(); it != this->players_.end(); ++it)
+        {
+            if (it->first->getClientID() == CLIENTID_UNKNOWN)
+                continue;
+            const std::string& message1 = "Remaining Players: "+ multi_cast<std::string>(playersAlive);
+            this->gtinfo_->sendStaticMessage(message1,it->first->getClientID(),ColourValue(1.0f, 1.0f, 0.5f));
+        }
+        
     }
 
@@ -142,4 +153,12 @@
             COUT(0) << message << std::endl;
             Host::Broadcast(message);
+            //Update: EachPlayer's "Players in Game"-HUD
+            for (std::map<PlayerInfo*, Player>::iterator it = this->players_.begin(); it != this->players_.end(); ++it)
+            {
+                if (it->first->getClientID() == CLIENTID_UNKNOWN)
+                    continue;
+                const std::string& message1 = "Remaining Players: "+ multi_cast<std::string>(playersAlive);
+                this->gtinfo_->sendStaticMessage(message1,it->first->getClientID(),ColourValue(1.0f, 1.0f, 0.5f));
+            }
         }
 
@@ -159,4 +178,31 @@
 
         return valid_player;
+    }
+
+    void LastManStanding::playerStartsControllingPawn(PlayerInfo* player, Pawn* pawn)
+    {
+        if (!player)
+            return;
+        //Update: Individual Players "lifes"-HUD
+        std::map<PlayerInfo*, Player>::iterator it2 = this->players_.find(player);
+        if (it2 != this->players_.end())
+        {
+            const std::string& message = "Your Lives: " +multi_cast<std::string>(playerLives_[player]);
+            this->gtinfo_->sendFadingMessage(message,it2->first->getClientID());
+
+        }
+    }
+
+    void LastManStanding::playerStopsControllingPawn(PlayerInfo* player, Pawn* pawn)
+    {
+        //Update: EachPlayer's "Players in Game"-HUD
+        for (std::map<PlayerInfo*, Player>::iterator it = this->players_.begin(); it != this->players_.end(); ++it)
+        {
+            if (it->first->getClientID() == CLIENTID_UNKNOWN)
+                continue;
+            const std::string& message1 = "Remaining Players : "+ multi_cast<std::string>(playersAlive);
+            this->gtinfo_->sendStaticMessage(message1,it->first->getClientID(),ColourValue(1.0f, 1.0f, 0.5f));
+        }
+    
     }
 
@@ -224,8 +270,8 @@
                 this->timeToAct_[player]=timeRemaining+3.0f;//reset timer
             }
+
         }
     }
     
-
     void LastManStanding::tick(float dt)
     {
Index: code/branches/lastmanstanding/src/orxonox/gametypes/LastManStanding.h
===================================================================
--- code/branches/lastmanstanding/src/orxonox/gametypes/LastManStanding.h	(revision 7578)
+++ code/branches/lastmanstanding/src/orxonox/gametypes/LastManStanding.h	(revision 7579)
@@ -30,10 +30,5 @@
     @brief Declaration of the Gametype "Last Man Standing".
 */
-/* BY THE WAY
-//!You have to ADD BOTS (or any other further players) BEFORE actually starting a match!
-//Maybe a warning should be added in the menu, if a player starts a Last Man Standing match alone.
-//Whenever there is only on player in the game, this player will be declared as winner.
-//How "death" is managed: dead players cannot respawn.
-*/
+
 #ifndef _LastManStanding_H__
 #define _LastManStanding_H__
@@ -72,11 +67,12 @@
             virtual void start(); //!< Sends a start message.
             virtual void end(); //!< Sends an end message.
-            virtual void playerEntered(PlayerInfo* player);
-            virtual bool playerLeft(PlayerInfo* player);
+            virtual void playerEntered(PlayerInfo* player); //!< Initializes values. Manages the gametype's HUD. #Players alive via StaticMessage.
+            virtual bool playerLeft(PlayerInfo* player); //!< Manages the gametype's HUD. #Players alive via StaticMessage.
             virtual bool playerChangedName(PlayerInfo* player);
-
+            virtual void playerStartsControllingPawn(PlayerInfo* player, Pawn* pawn); //!< Manages the gametype's HUD. player's lives via FadingMessage.
+            virtual void playerStopsControllingPawn(PlayerInfo* player, Pawn* pawn);  //!< Manages the gametype's HUD. #Players alive via StaticMessage.
             virtual void pawnKilled(Pawn* victim, Pawn* killer = 0);
 
-            const int playerGetLives(PlayerInfo* player); //!< getFunction for the map "playerLives_"
+            const int playerGetLives(PlayerInfo* player); //!< getFunction for the map "playerLives_".
             void killPlayer(PlayerInfo* player); //!< Function in order to kill a player. Punishment for hiding longer than "timeRemaining".
             void tick (float dt); //!< used to end the game