Index: branches/qt_gui/src/lib/gui/qt_gui/Makefile.am
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/Makefile.am	(revision 7584)
+++ branches/qt_gui/src/lib/gui/qt_gui/Makefile.am	(revision 7585)
@@ -21,5 +21,6 @@
 		\
 		gui_video.cc \
-		gui_audio.cc
+		gui_audio.cc \
+		gui_general.cc
 
 noinst_HEADERS= \
@@ -28,5 +29,7 @@
 		\
 		gui_video.h \
-		gui_audio.h
+		gui_audio.h \
+		gui_general.cc
+
 
 EXTRA_DIST =
Index: branches/qt_gui/src/lib/gui/qt_gui/gui_general.cc
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/gui_general.cc	(revision 7585)
+++ branches/qt_gui/src/lib/gui/qt_gui/gui_general.cc	(revision 7585)
@@ -0,0 +1,75 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+
+*/
+
+
+#include "gui_general.h"
+
+#include <QtGui/QLayout>
+#include "debug.h"
+
+#include "qt_gui_elements.h"
+
+namespace OrxGui
+{
+  /**
+   *  Creates the General-Option-Frame
+  */
+  GuiGeneral::GuiGeneral(OrxGui::Gui* gui)
+  : Element("General", gui), QGroupBox()
+  {
+    QGridLayout* layout = new QGridLayout(this);
+
+    {
+      QLabel* dataDirLabel = new QLabel("DataDirectory");
+      layout->addWidget(dataDirLabel, 0,0);
+      QtGuiInputLine* dataDir = new QtGuiInputLine("SoundCard", this);
+      layout->addWidget(dataDir, 0, 1, 1, 2);
+
+      QLabel* debugLabel = new QLabel("debug-mode");
+      layout->addWidget(debugLabel, 1,0);
+      QtGuiComboBox* debug = new QtGuiComboBox("debug", this);
+      layout->addWidget(debug, 1, 1, 1, 2);
+
+      debug->addItem("0 - minimal");
+      debug->addItem("1 - errors");
+      debug->addItem("2 - warnings");
+      debug->addItem("3 - information");
+      debug->addItem("4 - debug");
+      debug->addItem("5 - extremely debug");
+    }
+
+
+  }
+
+  /**
+   *  Destructs the General-stuff
+  */
+  GuiGeneral::~GuiGeneral()
+  {
+    // nothing to do here.
+  }
+
+
+}
Index: branches/qt_gui/src/lib/gui/qt_gui/gui_general.h
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/gui_general.h	(revision 7585)
+++ branches/qt_gui/src/lib/gui/qt_gui/gui_general.h	(revision 7585)
@@ -0,0 +1,25 @@
+/*!
+  \file gui_general.h
+  \brief File that holds the class that creates the General-Options.
+*/
+#ifndef _GUI_GENERAL_H
+#define _GUI_GENERAL_H
+
+#include "../gui_element.h"
+#include <vector>
+#include <string>
+#include <QtGui/QGroupBox>
+
+namespace OrxGui
+{
+  //! Class that creates the Audio-Options.
+  class GuiGeneral : public OrxGui::Element, public QGroupBox
+  {
+  public:
+    GuiGeneral(OrxGui::Gui* gui);
+    virtual ~GuiGeneral();
+
+  };
+}
+
+#endif /* _GUI_GENERAL_H */
Index: branches/qt_gui/src/lib/gui/qt_gui/qt_gui.cc
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/qt_gui.cc	(revision 7584)
+++ branches/qt_gui/src/lib/gui/qt_gui/qt_gui.cc	(revision 7585)
@@ -25,4 +25,5 @@
 #include "gui_video.h"
 #include "gui_audio.h"
+#include "gui_general.h"
 
 namespace OrxGui
@@ -43,4 +44,5 @@
         toolBox->addItem(new GuiVideo(this), "Video");
         toolBox->addItem(new GuiAudio(this), "Audio");
+        toolBox->addItem(new GuiGeneral(this), "General");
       }
       mainLayout->addWidget(toolBox,1,1, 1, 3);
Index: branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.cc
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.cc	(revision 7584)
+++ branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.cc	(revision 7585)
@@ -33,5 +33,5 @@
   {
     this->setTristate(value.getBool());
-        this->value() = value;
+    this->value() = value;
   }
 
@@ -81,3 +81,27 @@
 
 
+  QtGuiInputLine::QtGuiInputLine(const std::string& name, SaveableGroup* group)
+  : QLineEdit(), Saveable(name, group)
+  {
+
+
+  }
+
+
+  void QtGuiInputLine::load(const MultiType& value)
+  {
+    this->setText(value.getString().c_str());
+    this->value() = value;
+  }
+
+
+
+  const MultiType& QtGuiInputLine::save()
+  {
+    return this->value();
+  }
+
+
+
+
 }
Index: branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.h
===================================================================
--- branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.h	(revision 7584)
+++ branches/qt_gui/src/lib/gui/qt_gui/qt_gui_elements.h	(revision 7585)
@@ -70,4 +70,15 @@
   };
 
+  class QtGuiInputLine : public QLineEdit, public OrxGui::Saveable
+  {
+    Q_OBJECT
+
+  public:
+    QtGuiInputLine(const std::string& name, SaveableGroup* group);
+
+    virtual void load(const MultiType& value);
+    virtual const MultiType& save();
+  };
+
 }
 